hdu 4289 Control(最小割 + 拆点)

http://acm.hdu.edu.cn/showproblem.php?pid=4289

Control

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 2247    Accepted Submission(s): 940

Problem Description

  You, the head of Department of Security, recently received a top-secret information that a group of terrorists is planning to transport some WMD 1 from one city (the source) to another one (the destination). You know their date, source and destination, and they are using the highway network.
  The highway network consists of bidirectional highways, connecting two distinct city. A vehicle can only enter/exit the highway network at cities only.
  You may locate some SA (special agents) in some selected cities, so that when the terrorists enter a city under observation (that is, SA is in this city), they would be caught immediately.
  It is possible to locate SA in all cities, but since controlling a city with SA may cost your department a certain amount of money, which might vary from city to city, and your budget might not be able to bear the full cost of controlling all cities, you must identify a set of cities, that:
  * all traffic of the terrorists must pass at least one city of the set.
  * sum of cost of controlling all cities in the set is minimal.
  You may assume that it is always possible to get from source of the terrorists to their destination.
------------------------------------------------------------
1 Weapon of Mass Destruction

Input

  There are several test cases.
  The first line of a single test case contains two integer N and M ( 2 <= N <= 200; 1 <= M <= 20000), the number of cities and the number of highways. Cities are numbered from 1 to N.
  The second line contains two integer S,D ( 1 <= S,D <= N), the number of the source and the number of the destination.
  The following N lines contains costs. Of these lines the ith one contains exactly one integer, the cost of locating SA in the ith city to put it under observation. You may assume that the cost is positive and not exceeding 107.
  The followingM lines tells you about highway network. Each of these lines contains two integers A and B, indicating a bidirectional highway between A and B.
  Please process until EOF (End Of File).

Output

  For each test case you should output exactly one line, containing one integer, the sum of cost of your selected set.
  See samples for detailed information.

Sample Input

5 6

5 3

5

2

3

4

12

1 5

5 4

2 3

2 4

4 3

2 1

Sample Output

3

详细请参考:

http://www.cnblogs.com/liuxin13/p/4719335.html

题目大意:

N个点,每个点都有各自的cost, 然后M 无向条边

要求割去S点到D路线中的点,使之无法从S到D ,而且要求消耗的cost和最小.

这是一道网络流的题. 算的是最小割. 根据最大流最小割定理. 可以直接算最大流;

但是这题的的流量限制是在点上的.所以要我们来拆点.

我这题是把i 点的  点首和点尾 分别设为 i 和 i+n;  显然 最后会得到2*n个点

如图:

将点1拆分成两部分分别为点首1和点尾1+n,然后把点首到点尾的流量限制设成 题目要求的cost; ,点1---->(1+n)的花费即为封锁城市1的代价

而点与点之间(两座城市之间)的边,要设成正无穷大, 因为边不消耗cost;

然后从S的点首S 跑到 D的点尾 D+n  就可以计算出最小割了.

#include<stdio.h>
#include<algorithm>
#include<queue>
#include<string.h>
#define N 510
#define INF 0x3f3f3f3f
using namespace std;

struct Edge
{
    int u, v, flow, next;
} edge[N * N];

int layer[N], head[N], cnt;

void Init()
{
    memset(head, -1, sizeof(head));
    cnt = 0;
}

void AddEdge(int u, int v, int flow)
{
    edge[cnt].u = u;
    edge[cnt].v = v;
    edge[cnt].flow = flow;
    edge[cnt].next = head[u];
    head[u] = cnt++;

    swap(u, v);

    edge[cnt].u = u;
    edge[cnt].v = v;
    edge[cnt].flow = 0;
    edge[cnt].next = head[u];
    head[u] = cnt++;

}

bool BFS(int Start, int End)
{
    queue<int>Q;
    memset(layer, -1, sizeof(layer));
    Q.push(Start);
    layer[Start] = 1;
    while(!Q.empty())
    {
        int u = Q.front();
        Q.pop();
        if(u == End)
            return true;
        for(int i = head[u] ; i != -1 ; i = edge[i].next)
        {
            int v = edge[i].v;
            if(layer[v] == -1 && edge[i].flow > 0)
            {
                layer[v] = layer[u] + 1;
                Q.push(v);
            }
        }
    }
    return false;
}

int DFS(int u, int Maxflow, int End)
{
    if(u == End)
        return Maxflow;
    int uflow = 0;
    for(int i = head[u] ; i != -1 ; i = edge[i].next)
    {
        int v = edge[i].v;
        if(layer[v] == layer[u] + 1 && edge[i].flow > 0)
        {
            int flow = min(edge[i].flow, Maxflow - uflow);
            flow = DFS(v, flow, End);
            edge[i].flow -= flow;
            edge[i^1].flow += flow;

            uflow += flow;
            if(uflow == Maxflow)
                break;
        }
    }
    if(uflow == 0)
        layer[u] = 0;
    return uflow;
}

int Dinic(int Start, int End)
{
    int Maxflow = 0;
    while(BFS(Start, End))
        Maxflow += DFS(Start, INF, End);
    return Maxflow;
}

int main()
{
    int m, n, s, t;
    while(~scanf("%d%d", &m, &n))
    {
        Init();
        scanf("%d%d", &s, &t);
        int u, v, flow;
        for(int i = 1 ; i <= m ; i++)
        {
            scanf("%d", &flow);
            AddEdge(i, i + m, flow);
        }
        while(n--)
        {
            scanf("%d%d", &u, &v);
            AddEdge(u + m, v, INF);
            AddEdge(v + m, u, INF);
        }
        printf("%d\n", Dinic(s, t + m));
    }
    return 0;
}

时间: 2024-08-08 21:51:39

hdu 4289 Control(最小割 + 拆点)的相关文章

HDU 4289 Control 最小割

Control 题意:有一个犯罪集团要贩卖大规模杀伤武器,从s城运输到t城,现在你是一个特殊部门的长官,可以在城市中布置眼线,但是布施眼线需要花钱,现在问至少要花费多少能使得你及时阻止他们的运输. 题解:裸的最小割模型,最小割就是最大流,我们把点拆成2个点,然后将原点与拆点建边,流量为在城市建立眼线的费用,然后拆点为出点,原点为入点,将可以到达的城市之间建流量为无穷的边. 最后求出s 到 t的拆点的最大流 那么就是这个题目的答案了. 代码: 1 #include<bits/stdc++.h>

HDU - 4289 Control (最小割 MCMF)

题目大意:有一个间谍要将一些机密文件送到目的地 现在给出间谍的初始位置和要去的目的地,要求你在间谍的必经路上将其拦获且费用最小 解题思路:最小割最大流的应用,具体可以看网络流–最小割最大流 建图的话 超级源点–起始城市,容量为INF 城市拆成两点(u, v),容量为监视该城市的代价 能连通的城市连接,容量为INF 目的地和超级汇点相连,容量为INF #include <cstdio> #include <cstring> #include <algorithm> #in

HDU 4289 Control (最大流+拆点)

http://acm.hdu.edu.cn/showproblem.php?pid=4289 题目讲的是有一些恐怖分子要从S市去往D市,要求在一些城市中安排特工,保证一定能够抓住恐怖分子,因为安排特工需要一定的费用,所以希望找出最小的花费. 思路:可以把每个城市,即每个点拆分成进来的点和出去的点,如x点分成x和x+n,两点连接的边权值为x点上安排特工的费用.而如果x和y两点有连线,则连接x+n,y,然后求从S市到达D市的最大流.之所以能这样求,是因为在求最大流的过程中每次所更新的流量是所有边中最

hdu-4289.control(最小割 + 拆点)

Control Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 5636    Accepted Submission(s): 2289 Problem Description You, the head of Department of Security, recently received a top-secret informati

HDU 4289 Control (网络流-最小割)

Control Problem Description You, the head of Department of Security, recently received a top-secret information that a group of terrorists is planning to transport some WMD 1 from one city (the source) to another one (the destination). You know their

hdu 4289 Control(网络流 最大流+拆点)(模板)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=4289 Control Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 1545    Accepted Submission(s): 677 Problem Description You, the head of Department o

hdu 4289 Control (最大流)

hdu 4289 Control You, the head of Department of Security, recently received a top-secret information that a group of terrorists is planning to transport some WMD 1 from one city (the source) to another one (the destination). You know their date, sour

poj 1815 Friendship (最小割+拆点+枚举)

题意: 就在一个给定的无向图中至少应该去掉几个顶点才能使得s和t不联通. 算法: 如果s和t直接相连输出no answer. 把每个点拆成两个点v和v'',这两个点之间连一条权值为1的边(残余容量) v和v''分别是一个流进的点,一个流出的点. 根据求最小割的性质,权值小的边是可能被选择的(断开的). 添加源点st=0和汇点en=2*n+1,源点与s连权值为inf的边,t''与汇点连权值为inf的边. s与s'',t与t''连权值为inf的边,这样保证自己和自己是不会失去联系的. 如果i和j有边

HDU 4289 Control (最小割 拆点)

Control Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 2139    Accepted Submission(s): 904 Problem Description You, the head of Department of Security, recently received a top-secret informati